# coding: utf-8

"""
    FINBOURNE Workflow API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, constr, validator

class HealthCheck(BaseModel):
    """
    Configuration for a Worker that performs a GET against a given Url.  # noqa: E501
    """
    type: constr(strict=True, min_length=1) = Field(..., description="The type of worker")
    url: constr(strict=True, max_length=2048, min_length=1) = Field(..., description="The URL to check, eg: https://www.google.com/")
    __properties = ["type", "url"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('HealthCheck'):
            raise ValueError("must be one of enum values ('HealthCheck')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HealthCheck:
        """Create an instance of HealthCheck from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HealthCheck:
        """Create an instance of HealthCheck from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HealthCheck.parse_obj(obj)

        _obj = HealthCheck.parse_obj({
            "type": obj.get("type"),
            "url": obj.get("url")
        })
        return _obj
